REM  *****  BASIC  *****

'/** IX_SeiteDrucken
'*************************************************************************.
'* @kurztext  druckt die aktuelle Seite (dort, wo sich der Viewcursor befindet)
'* Das Makro druckt die aktuelle Seite auf den aktuellen Drucker aus. Die aktuelle
'* definiert sich dabei durch die Position des Viewcursors (dem blinkenden Cursor),
'* diese kann abweichen von der tatschlichen Sichtseite.
'*************************************************************************
'*/
Sub IX_SeiteDrucken
  dim oViewC as variant
  
  REM ausschliessen, dass die "Seitenansicht" eingeschaltet ist
  if thisComponent.currentController.frame.layoutManager.isElementVisible( _
          "private:resource/toolbar/previewobjectbar") then
     msgbox "Die Zusatzfunktion ""aktuelle Seite drucken"" ist in der" & chr(13) & _
            "Seitenvorschauansicht nicht verfgbar. Bitte verlassen Sie diese" & chr(13) & _
            "Darstellung (ber den Button ""Seitenansicht schlieen"") oder nutzen" & chr(13) & _
            "Sie die Funktion ""Seitenansicht drucken"" - zweites Icon links" & chr(13) & _
            "neben ""Seitenansicht schlieen""."
     exit sub       
  end if

  REM Fehler sonstiger Art ausschlieen (kein Viewcursor)
  on error goto fehlerVC
  oViewC = thisComponent.getCurrentController.getViewCursor()
  dim arg(0) as new com.sun.star.beans.PropertyValue
  arg(0).name = "Pages"
  arg(0).value = """" & thisComponent.getCurrentController().getViewCursor().page & """"
  thisComponent.print(arg())
 
exit sub
fehlerVC: 
  msgbox "Die Funktion ""aktuelle Seite drucken"" lsst sich derzeit nicht" & chr(13) & _
         "ausfhren. Es liegt ein unbekannter Fehler vor."

End Sub


